\name{weightLabels-methods}
\docType{methods}
\alias{weightLabels-methods}
\alias{weightLabels}
\alias{weightLabels.graphNEL}
\alias{weightLabels,graph-method}
\title{A method for providing edge weights for labels}
\description{This method is used primarily as a convenience for users
  who wish to display the edge weights as labels in their plots.}
\section{Usage}{
  \code{weightLabels(object)}
}
\section{Arguments}{
  \item{object}{The \code{graphNEL} object to retrieve the weights for}
}
\section{Details}{
  This method will return a list for every node that contains a named
  character vector representing the weights (in string form) of every
  edge from that node.  The names of the vector are the character name
  of the node that the edge goes to.  This is the format expected by the
  \code{edgeLabels} parameter of the \code{plot} method.

  This list differs from the one returned by \code{edgeWeights} in that
  the latter contains a named vector where the weights are numeric and
  the names are the numeric index of the node the edge goes to.
}
\section{Author}{Jeff Gentry}
\section{seealso}{\code{\link{graph-class}}, \code{link{plot.graph}}}
\keyword{methods}

